      program rpc_sim

* Author J.Repond. Version of April 21, 2010
* added transfer of interaction layer information to atuple

      implicit none

      integer i1,i2,i3,i4,i5,i6
      integer i_event,n_event,n_point
      integer i_pad_x,i_pad_y
      integer hit(0:350,0:350,0:150)
      integer z_store(0:10000),z_tmp(10000),f_tmp(10000),n_tmp
      integer i_int,n_int,inter_layer,inter_layer_new

      real r1,r2,r3,r4,r5
      real e,x,y,z,Q
      real T,Q0
      real par(3)
      real x_store(0:10000),y_store(0:10000)
      real x_tmp(10000),y_tmp(10000),dist_cut
      real x_int,y_int,radius_max
      real q_int,q_tot,slope1,slope2,ratio
      real q_integral1,q_integral2,q_integral,q_check
      real q_pad(0:600,0:600,0:600)
      real x_deposit,y_deposit
      real x_crack(2),x_scaler,y_crack(4),y_scaler

      character*12 file0
      character*3  file1
      character*7  file2
      character*4  file3
      character*25 file4

*      data par /0.00057,1.735,0.0012/  ! 6.2 kV
*      data par /0.00007,1.951,0.0010/  ! 6.3 kV      data par /0.00001,2.167,0.0008/  ! 6.4 kV
      data par /0.00001,2.167,0.0008/  ! 6.4 kV


* units are cm

      data n_int /10000/                ! Number of points in distributed charge
      data radius_max /4.0/             ! Maximum extent of charge, default = 3.0
      data y_crack /0.005,32.525,65.065,97.595/ ! Cracks in y

* the famous 6 parameters 

      data slope1   /0.0678/                ! Slope1 of exponential charge distribution; default = 0.0678
      data slope2   /0.671/                ! Slope2 of exponential charge distribution; default = 0.671
      data ratio    /0.345/                   ! Ratio of contribution from slope1 and slope2; default = 0.345
      data T        /0.3645/                     ! Threshold (in pC); default = 0.3645
      data dist_cut /0.092/               ! Minimum distance between hits in x,y plane; default = 0.092
      data Q0       /+0.201/                     ! offset in charge; default = +0.201
      data file2 /'.otuple'/

* MC output files

*      data file0 /'../mc1/Muon.'/
      data file0 /'../mc1/Posi.'/
*      data file0 /'../mc1/Pion.'/
      data file3 /'.txt'/
*      data file4 /'/HEPdata/ILC/repond/Posi.'/
      data file4 /'/HEPdata/ILC/repond/Muon.'/
*      data file4 /'/HEPdata/ILC/repond/Test.'/

* setup 

      i_event=0
      n_event=0

      write(6,*) 'Type run number'
      read(5,*) file1
*      open(unit=61,status='OLD',file=file0//file1//file3)    
      open(unit=61,status='OLD',file=file4//file1//file3)     ! for Posi.007.txt and beyond
      open(unit=62,status='UNKNOWN',file=file4//file1//file2) ! the output atuple

      read(61,*) z_store(0),x_store(0),y_store(0)
      inter_layer=x_store(0)

* calculate integral over charge distribution

      q_integral1=6.283*slope1**2*(1.-exp(-radius_max/slope1)*
     >  (1.+radius_max/slope1))
      q_integral2=6.283*slope2**2*(1.-exp(-radius_max/slope2)*
     >  (1.+radius_max/slope2))


**  get x,y,z of energy deposit

 1    continue
      i_event=i_event+1
      n_event=n_event+1
      if(n_event.ge.100) then
        write(6,*) i_event
        n_event=0
      endif
      if(i_event.gt.60000) stop

* read in from file (generated by MC)

      n_point=1
 5    continue

      read(61,*,err=4,end=4) z_store(n_point),
     > x_store(n_point),y_store(n_point)

      if(z_store(n_point).ge.0) then
        x_store(n_point)=x_store(n_point)/10.
        y_store(n_point)=y_store(n_point)/10.
        n_point=n_point+1
        goto 5
      else
        x_store(0)=x_store(n_point)
        y_store(0)=y_store(n_point)
        z_store(0)=z_store(n_point)
        n_point=n_point-1
      endif
      inter_layer_new=x_store(0)

* clean up hits (eliminate close by hits)

      do i1=1,n_point
        f_tmp(i1)=1      ! 0 = discard point, 1 = keep point
      enddo

      do i1=1,n_point-1
        if(f_tmp(i1).eq.1) then
          do i2=i1+1,n_point
            if(z_store(i1).eq.z_store(i2).and.
     >       f_tmp(i2).eq.1) then
              r1=sqrt((x_store(i1)-x_store(i2))**2+
     >         (y_store(i1)-y_store(i2))**2)
              if(r1.lt.dist_cut) f_tmp(i2)=0
            endif
          enddo
        endif
      enddo

      n_tmp=0
      do i1=1,n_point
        if(f_tmp(i1).eq.1) then
          n_tmp=n_tmp+1
          x_tmp(n_tmp)=x_store(i1)
          y_tmp(n_tmp)=y_store(i1)
          z_tmp(n_tmp)=z_store(i1)
        endif 
      enddo

      do i1=1,n_tmp
        x_store(i1)=x_tmp(i1)
        y_store(i1)=y_tmp(i1)
        z_store(i1)=z_tmp(i1)
      enddo
      n_point=n_tmp

* reset pad array and pad charges

      do i1=0,150
        do i2=0,150
          do i3=0,150
            hit(i3,i2,i1)=0
            q_pad(i3,i2,i1)=0.
          enddo
         enddo
      enddo

* loop over all points in event

      do i1=1,n_point

* get x,y

        x=x_store(i1)
        y=y_store(i1)

* determine id of pad hit

        i_pad_x=int(x)
        i_pad_y=int(y)

* determine minimum distance to boundaries in x and y

        x_crack(1)=x+48.0
        x_crack(2)=96.0-(x+48.0)
        x_scaler=amin1(x_crack(1),x_crack(2))

        y_scaler=999.
        do i2=1,4
          r1=abs(y-y_crack(i2)+48.8)
          if(r1.le.y_scaler) y_scaler=r1
        enddo

* generate charge: Distributed like RABBIT data

 2      r1=rand(0)*12000.
        r2=par(1)*r1**par(2)*exp(-r1*par(3))
        r3=rand(0)*40.
        if(r2.gt.r3) then
          Q=r1/1100.
        else
          goto 2 
        endif

* Introduce offset 

        Q=Q-Q0

* Adjust charge close to boundary

        if(x_scaler.lt.10.0) Q=Q*((x_scaler/10.0)**0.7)
        if(y_scaler.lt.10.0) Q=Q*((y_scaler/10.0)**0.25)
        if(y_scaler.lt.1.0) Q=Q/6.
*        if(x_scaler.lt.10.0) Q=Q*(1.-exp(-x_scaler/0.05))
*        if(y_scaler.lt.10.0) Q=Q*(1.-exp(-y_scaler/0.05))

* Distribute charge according to STAR measurements

        
* integrate with n_int points

        i_int=0
        q_check=0.
 3      continue
        x_int=2.*radius_max*(rand(0)-.5)
        y_int=2.*radius_max*(rand(0)-.5)
        r1=sqrt(x_int**2+y_int**2)
        if(r1.gt.radius_max) goto 3
        i_int=i_int+1

* calculate charge

        q_int=exp(-r1/slope1)*(1.-ratio)*(Q/real(n_int)/q_integral1)*3.142*radius_max**2+
     >   exp(-r1/slope2)*(ratio*Q/real(n_int)/q_integral2)*3.142*radius_max**2
        q_check=q_check+q_int

* deposit charge on corresponding pad

*        i2=int(x+x_int)+300
*        i3=int(y+y_int)+300

        x_deposit=x+x_int+48.0     ! x of deposited charge in cm, centered onto plane
        y_deposit=y+y_int+48.8     ! y of deposited charge in cm, centered onto plane

        if(x_deposit.lt.0.0.or.x_deposit.gt.96.0) q_int=0. ! set charge to zero if off the boards in x

        i2=int(x_deposit)                ! pad index in x

        if(y_deposit.lt.0.27) then
          q_int=0.                       ! set charge to zero if off the boards in y
        elseif(y_deposit.gt.32.27.and.y_deposit.lt.32.8) then
          q_int=0.
        elseif(y_deposit.gt.64.8.and.y_deposit.lt.65.33) then
          q_int=0.
        elseif(y_deposit.gt.97.33) then
          q_int=0.
        endif

        if(y_deposit.le.32.27) then      ! pad index in y
          i3=int(y_deposit-0.27)
        elseif(y_deposit.le.64.80) then
          i3=int(y_deposit-0.8)
        elseif(y_deposit.le.97.33) then
          i3=int(y_deposit-1.33)
        else
          i3=0
        endif

*        write(70,*) 'x,y,x_int,y_int',x,y,x_int,y_int
*        write(70,*) 'x_deposit,y_deposit',x_deposit,y_deposit
*        write(70,*) 'padx,pady',i2,i3

        i4=z_store(i1)                   ! pad index in z

        q_pad(i2,i3,i4)=q_pad(i2,i3,i4)+q_int          
        if(i_int.lt.n_int) goto 3

      enddo

* determine pads hit 

      do i1=0,150
        do i2=0,150
          do i3=0,150
            if(q_pad(i1,i2,i3).gt.T) hit(i1,i2,i3)=1
          enddo
        enddo
      enddo

* write out hits

      write(62,*) i_event,inter_layer,-1,-1
      do i3=0,150
        do i2=0,200
          do i1=0,200
            if(hit(i1,i2,i3).eq.1) then
              write(62,*) i_event,i1,i2,i3
            endif
          enddo
        enddo
      enddo

* check total charge

*      write(60,*) q,q_check

* get next event

      inter_layer=inter_layer_new
      goto 1

* finish up

 4    continue

      stop
      end
